package com.etest.statictest.utils;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.io.FilenameUtils;
import org.springframework.util.FileCopyUtils;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.HashMap;
import java.util.UUID;

@Slf4j
public class FileUtil {

/**
 * target classes路径
 */

    public static final String CLASSESPATH = System.getProperty("user.dir") + "/target/classes";
/**
 *  服务器路径：
 */
public static final String SERVERPATH = System.getProperty("user.dir") + "/src/main/resources";


    /**
     * 上传到服务器中
     * 复制到classes中
     * 判断时，判断文件夹是否存在，不是判断这个文件是否存在
	 * @author nan
     * @param uploadFile
     * @param name
     * @return
     */
    public static HashMap<String, String> upload(MultipartFile uploadFile, String name) {
        String urlName = "/static/file/" + name;
        try {
			
                    //判断文件的大小，文件超过限制值得话提示文件大小超出限制(Bytes)
                 //   Long fileLength = uploadFile.getSize();
                 //   System.out.println(fileLength);
                  //  if(fileLength / 1024 / 1024 <= 100){//限制文件大小为100Mb
                 //       saveFile = new File("G:/DEVTools/apache/apache-tomcat-8.5.35/webapps/ROOT/photo/" + fileName);
                   //     saveFilePath = "G:/DEVTools/apache/apache-tomcat-8.5.35/webapps/ROOT/photo/" + fileName;
                   // }else{
                   //     return WebResult.failure("上传文件大小超出100Mb限制,请重新选择文件！").toMap();
                  //  }
					
            HashMap<String, String> map = new HashMap<>();
//            2.0得到你当前运行文件在服务器上的 打包classes的 绝对路径 文件夹
            String classesPath = CLASSESPATH + urlName;
            log.debug("classes的 绝对路径:" + classesPath);

//            2.0 得到你当前运行文件在服务器上的绝对路径 文件夹
            String serverPath = SERVERPATH + urlName;

            log.debug("服务器上的绝对路径:" + serverPath);
//            2.1 获取原始名字 后缀不能修改
            String originalFilename = uploadFile.getOriginalFilename();
            //            2.2 获取后缀
            String extensionFilename = FilenameUtils.getExtension(originalFilename);

            //            2.3 得到新的名字
            String newFilename = UUID.randomUUID().toString() + "." + extensionFilename;

//            classes的目录文件夹
            File classesFolder = new File(classesPath);
//            classes的 绝对路径 文件
            File classesFile = new File(classesPath + newFilename);
//            服务器目录文件夹
            File serverFolder = new File(serverPath);
//            服务器文件
            File serverFile = new File(serverPath + newFilename);

//            classes复制的，判断文件夹是否存在
            if (classesFolder.exists()) {
                if (classesFolder.isDirectory()) {
                    log.info("classes目录存在");
                } else {
                    log.info("classes同名文件存在, 不能创建");
                }
            } else {
                classesFolder.mkdirs();
                log.info("classes目录不存在，创建目录");
            }

//            服务器文件 判断文件夹是否存在，如果不存在创建
            if (serverFolder.exists()) {
                if (serverFolder.isDirectory()) {
                    log.info("serverFile目录存在");
                } else {
                    log.info("serverFile同名文件存在, 不能创建");
                }
            } else {
                serverFolder.mkdirs();
                log.info("serverFile目录不存在，创建目录");
            }

//            保存到服务器文件夹中
            uploadFile.transferTo(serverFile);
            //复制到classes中
            int copy = FileCopyUtils.copy(serverFile, classesFile);// 文件拷贝工具类
            if (copy > 0) {
                log.debug("文件拷贝成功。。。：" + copy);
            } else {
                log.debug("文件拷贝失败。。。:" + copy);
            }
            map.put("newFilename", urlName + newFilename);
            map.put("originalFilename", originalFilename);
            map.put("extensionFilename", extensionFilename);
            return map;
        } catch (IOException e) {
            e.printStackTrace();
            return null;
        }
    }

    /**
     * 得到你当前运行文件在服务器上的绝对路径
     * Classes 删除
     *
     * @param name
     * @return
     */
    public static boolean delFile(String name) {
        File classesFile = new File(CLASSESPATH + name);
        File serverFile = new File(SERVERPATH + name);
        boolean b = false;
        if (classesFile.exists()) {
            classesFile.delete();
            classesFile.delete();
            b = true;
        }
        if (serverFile.exists()) {
            serverFile.delete();
            serverFile.delete();
            b = true;
        }
        return b;
    }


    public static void main(String[] args) throws FileNotFoundException {
//        String path = ClassUtils.getDefaultClassLoader().getResource("").getPath() + "static/file/contact";
//        String path1 = ResourceUtils.getURL("classpath:").getPath();
//        File file = new File(path);
//        如果存在的话返回“true”，否则就是返回“false
//        if (!file.exists()) {
//            if (file.mkdirs()) {
//                log.debug("==> 创建文件成功。。。");
//            } else {
//                log.debug("==> 创建文件失败。。。");
//            }
//
//        }
        String path = System.getProperty("user.dir");
//        String serverpath= ResourceUtils.getURL("classpath:static/file/").getPath().substring(1);


//        String pathFile = url.getFile(); //如果是中文路径 pathfile是路径里面是乱码

        //需要进行decode才能正常显示中文路径

//        try {
//            String urlPath= URLDecoder.decode(CLASSESPATH,"utf-8");
//            log.debug(urlPath);
//        } catch (UnsupportedEncodingException e) {
//            e.printStackTrace();
//        }
        log.debug(SERVERPATH);
//        log.debug(urlPath);
//        log.debug( ClassUtils.getDefaultClassLoader().getResource("").getPath());
//        log.debug(serverpath);
        log.debug(CLASSESPATH);
    }
}
